unit Search;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TfrmSearch = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    PageControl1: TPageControl;
    TSNormal: TTabSheet;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    edtSearchStr: TEdit;
    chkTitle: TCheckBox;
    chkName: TCheckBox;
    chkContent: TCheckBox;
    GroupBox1: TGroupBox;
    cbbRoom: TComboBox;
    TSCustom: TTabSheet;
    memSearch: TMemo;
    cbbLogic: TComboBox;
    Label2: TLabel;
    Memo1: TMemo;
    procedure btnOKClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    sltRoomsKey:TStringlist;            //˱дCbbRoomRoomIDĶӦϵ

    function prockeyword(KeyType,KeyWord,Flag:string):string;
  public
    { Public declarations }
    SearchStr:string;
    Target:string;
    TitleOnly:boolean;    
    Return:boolean;
  end;

var
  frmSearch: TfrmSearch;

implementation

uses
    main, dm;

{$R *.DFM}

procedure TfrmSearch.btnOKClick(Sender: TObject);
var
        ssCondition,SFlag:string;
begin
     if PageControl1.ActivePageIndex = 1 then
     begin
           SearchStr := memSearch.Text;
           Target := 'Զ';
           Return := true;
           Close;
           exit;
     end;

     if edtSearchStr.Text = '' then
     begin
          messagebox(Handle,'Ҫݣ' ,'',mb_ok or MB_ICONWARNING);
          exit;
     end;

     if (not chkTitle.Checked) and (not chkName.Checked) and (not chkContent.Checked) then
     begin
          messagebox(Handle,'ѡһѡ' ,'',mb_ok or MB_ICONWARNING);
          exit;
     end;

     Return := true;
     TitleOnly := true;
     ssCondition := '';

     SFlag := cbbLogic.Items[cbbLogic.itemindex];

     if cbbRoom.ItemIndex <> 0 then
     begin
//          ssCondition := ssCondition + ' (roomid =' + inttostr(DM1.GetRoomID(cbbRoom.Items[cbbRoom.ItemIndex])) + ' ) and ';
          ssCondition := ssCondition + ' (roomid =' + sltRoomsKey.Values[inttostr(cbbRoom.Itemindex)] + ' ) and ';
     end;

     if chkTitle.Checked then ssCondition := ssCondition + prockeyword('subject', edtSearchStr.Text, SFlag) + ' or';

     if chkName.Checked then
     begin
     ssCondition := ssCondition + prockeyword('userfrom', edtSearchStr.Text, SFlag) + ' or';
     TitleOnly := false;
     end;

     if chkContent.Checked then
     begin
     ssCondition := ssCondition + prockeyword('content', edtSearchStr.Text, SFlag) + ' or';
     TitleOnly := false;
     end;

     ssCondition := copy(ssCondition,1,length(ssCondition)-2);

//     SearchStr := 'select id,subject,userfrom,points,regdatetime,replytimes,status from letters where (' + ssCondition + ') and (parent = 0) ' ;
     SearchStr := ' where (' + ssCondition + ') and (parent = 0) ' ;

     if TitleOnly = false then
     begin
//        SearchStr := 'select id,subject,userfrom,points,regdatetime,replytimes,status from letters where (' + ssCondition + ') and (parent = 0) ' ;
//        SearchStr := SearchStr + ' union select id,subject,userfrom,points,regdatetime,replytimes,status from letters where id in (select parent from letters where (parent <> 0) And (' + ssCondition + ')) ';
        SearchStr := ' where (' + ssCondition + ') and (parent = 0) ' ;
     end;

     Target := ''+'' + edtSearchStr.Text + '';
     close;
end;

procedure TfrmSearch.btnCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TfrmSearch.FormCreate(Sender: TObject);
var
        i:integer;
begin
     Return := false;

     sltRoomsKey := TStringList.Create;

     cbbRoom.Items.Clear;
     cbbRoom.Items.Add('ȫ');
     cbbLogic.ItemIndex := 0;
     sltRoomsKey.Add('0=-1');

     for i := 0 to DM1.sltRooms.Count - 1 do
     begin
            cbbRoom.Items.Add(DM1.sltRooms.Values[DM1.sltRooms.Names[i]]);
            sltRoomsKey.Add(inttostr(i + 1) + '=' + DM1.sltRooms.Names[i]);
     end;

     cbbRoom.ItemIndex := 0;

//     frmSearch.FocusControl(edtSearchStr);
end;

function TfrmSearch.prockeyword(KeyType,KeyWord,Flag:string):string;
var
        tmp1:string;
begin
        KeyWord := ' ' + Trim(KeyWord);
        tmp1 := StringReplace(KeyWord,' ','%'' ' + Flag + ' ' + KeyType + ' like ''%', [rfReplaceAll]); 
        Result := copy(tmp1,7,length(tmp1)) + '%'' ';
end;

procedure TfrmSearch.FormDestroy(Sender: TObject);
begin
        sltRoomsKey.free;
end;

end.
