unit option;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls;

type
  TfrmOption = class(TForm)
    PageControl1: TPageControl;
    TSDBSourse: TTabSheet;
    btnOK: TButton;
    lsbDs: TListBox;
    memDsname: TMemo;
    btnDsadd: TButton;
    btnDsdel: TButton;
    btnDsconf: TButton;
    edtDsname: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure btnOKClick(Sender: TObject);
    procedure lsbDsClick(Sender: TObject);
    procedure edtDsnameExit(Sender: TObject);
    procedure btnDsaddClick(Sender: TObject);
    procedure btnDsdelClick(Sender: TObject);
    procedure btnDsconfClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure init;
    procedure RefreshDataSource;
  public
    { Public declarations }
  end;

var
  frmOption: TfrmOption;

implementation

uses optdata, main, dm;

{$R *.DFM}

procedure TfrmOption.btnOKClick(Sender: TObject);
begin
        DsList.SaveToFile;
        close;
end;

procedure TfrmOption.init;
begin
        
end;

procedure TfrmOption.RefreshDataSource;
var
        i:integer;
begin
        with lsbDs do
        begin
                items.Clear;
                for i := 0 to DsList.Count - 1 do
                begin
                        Items.Add(DsList.Items[i].Name);
                end;
        end;
        if lsbDs.Items.Count <> 0 then
        begin
                lsbDs.ItemIndex := lsbDs.Items.Count - 1;
                lsbDsClick(self);
        end;
end;

procedure TfrmOption.lsbDsClick(Sender: TObject);
var
        i:integer;
begin
        i := lsbDs.ItemIndex;
        if i = -1 then exit;
        edtDsname.Text := DsList.Items[i].Name;
        memDsname.Lines.Text := DsList.Items[i].connstr;
end;

procedure TfrmOption.edtDsnameExit(Sender: TObject);
var
        i:integer;
        ds:TDataSourceInfo;
begin
        if lsbDs.Items.Count = 0 then exit;
        i := lsbDs.ItemIndex;
        ds.Name := edtDsname.Text;
        ds.connstr := memDsname.Lines.Text;
        DsList.Items[i] := ds;
        lsbDs.Items[i] := edtDsname.Text; 
end;

procedure TfrmOption.btnDsaddClick(Sender: TObject);
var
        ds:TDataSourceInfo;
begin
        ds.Name := 'Դ';
        ds.connstr := 'connstr';
        DsList.Add(ds);
        RefreshDataSource;
end;

procedure TfrmOption.btnDsdelClick(Sender: TObject);
begin
        DsList.Delete(lsbDs.ItemIndex);
        RefreshDataSource;
end;

procedure TfrmOption.btnDsconfClick(Sender: TObject);
begin
        memDsname.Text := DM1.ConfigConnstr;
        edtDsnameExit(self);
end;

procedure TfrmOption.FormCreate(Sender: TObject);
begin
        RefreshDataSource;
end;

end.
